local FantasyImport, _HomePrefix = ...

-- Apply building asset processor
FantasyImport:registerAssetProcessor("models/fantasyImport.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

FantasyImport:registerAssetId("models/fantasyImport.fbx/Prefab/fantasyImportWindowPart", _HomePrefix .. "_FANTASY_IMPORT_WINDOW_PREFAB")

FantasyImport:registerPrefabComponent("models/fantasyImport.fbx/Prefab/fantasyImportWindowPart", {
    DataType = "COMP_BUILDING_PART",
    BuildingPartType = "MINOR"
})

function registerFantasyImportWindow(_asset)
    FantasyImport:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_FANTASY_IMPORT_" .. _asset .. "_PART",
	    Name = _asset .. "_NAME",
	    Description = _asset .. "_DESC",
	    Category = "CORE",
	    BuildingZone = {},
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { _HomePrefix .. "_FANTASY_IMPORT_WINDOW_PREFAB" },
                AssemblageSetList = {{
                    DataType = "ASSEMBLAGE_CUSTOM_SET",
                    CustomValueList = {
                        { BuildingPart = _asset .. "_PART", AttachNodeString = "Attach_Major_fantasy_import" },
                    }                         
                }},
            }
    })
    FantasyImport:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_FANTASY_IMPORT_" .. _asset .. "_2_PART",
	    Name = _asset .. "_NAME",
	    Description = _asset .. "_DESC",
	    Category = "CORE",
	    BuildingZone = {},
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = { _HomePrefix .. "_FANTASY_IMPORT_" .. _asset .. "_PART" },
            },
})end

registerFantasyImportWindow("WINDOW1")
registerFantasyImportWindow("WINDOW2")
registerFantasyImportWindow("WINDOW3")
registerFantasyImportWindow("WINDOW4")
registerFantasyImportWindow("WINDOW5")

function registerFantasyImportDoorPrefab(_orientation, _asset)
   FantasyImport:registerAssetId("models/fantasyImport.fbx/Prefab/fantasyImportDoor" .. _orientation .. "Part", _HomePrefix .. "_FANTASY_IMPORT_DOOR_" .. _asset .. "_PREFAB")
-- Register grounding components
   FantasyImport:registerPrefabComponent("models/fantasyImport.fbx/Prefab/fantasyImportDoor" .. _orientation .. "Part", {
	DataType = "COMP_GROUNDED"
   })

   FantasyImport:registerPrefabComponent("models/fantasyImport.fbx/Prefab/fantasyImportDoor" .. _orientation .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "DOOR"
   })
end
registerFantasyImportDoorPrefab("Recto", "RECTO")
registerFantasyImportDoorPrefab("Verso", "VERSO")

function registerFantasyImportDoor(_asset, _orientation, _orientationOffset)
    FantasyImport:registerAsset({
	  DataType = "BUILDING_PART",
	  Id = _HomePrefix .. "_FANTASY_IMPORT_" .. _orientation .. "_" .. _asset .. "_PART",
	  Name = _asset .. "_NAME",
	  Description = _asset .. "_DESC",
	  Category = "DOOR",
	  BuildingZone = {},
	  ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { _HomePrefix .. "_FANTASY_IMPORT_DOOR_" .. _orientation .. "_PREFAB" },
            AssemblageSetList = {{
                DataType = "ASSEMBLAGE_CUSTOM_SET",
                CustomValueList = {
                    { BuildingPart = _asset .. "_PART", AttachNodeString = "Attach_Major_fantasy_import" },
                }                         
            }},
        },
        IsVisibleWhenBuilt = true,
    })
    FantasyImport:registerAsset({
	  DataType = "BUILDING_PART",
	  Id = _HomePrefix .. "_FANTASY_IMPORT_" .. _orientation .. "_" .. _asset .. "_2_PART",
	  Name = _asset .. "_NAME",
	  Description = _asset .. "_DESC",
	  Category = "CORE",
	  BuildingZone = {},
	  ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = { _HomePrefix .. "_FANTASY_IMPORT_" .. _orientation .. "_" .. _asset .. "_PART" },
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = true,
                        OrientationOffset = _orientationOffset,

                }
        },
    })
end

function registerFantasyImportDoors(_asset)
    registerFantasyImportDoor(_asset, "RECTO", 180)
    registerFantasyImportDoor(_asset, "VERSO", 0)
end
registerFantasyImportDoors("WOODEN_DOOR1")
registerFantasyImportDoors("WOODEN_DOOR2")
registerFantasyImportDoors("WOODEN_DOOR3")
registerFantasyImportDoors("WOODEN_DOOR4")
registerFantasyImportDoors("WOODEN_DOOR5")
registerFantasyImportDoors("WOODEN_DOOR6")
registerFantasyImportDoors("WOODEN_DOOR7")

