local StoneGate = ...

-- Apply building asset processor
StoneGate:registerAssetProcessor("models/decorations/pinion.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register Decorations materials
StoneGate:registerAssetId("models/decorations/pinion.fbx/Materials/murChateau", StoneGateSetPrefix .. "_DECORATIONS_PINION_STONE_MANOR_WALL_MATERIAL")

-- Create default minor decoration part registering function 
function registerDefaultMinorDecorationPart(_nameFbxFile, _nameFbx, _nameAsset, _stoneCost, _buildingPartType, _category)
    StoneGate:registerAssetId("models/decorations/" .. _nameFbxFile .. ".fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_PREFAB")

    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_DESC",
	Category = _category,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _stoneCost*_NoSandbox }
		}}
	},
        IsVisibleWhenBuilt = ttrue
    })

    StoneGate:registerPrefabComponent("models/decorations/" .. _nameFbxFile .. ".fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = _buildingPartType
    })
end

function registerDefaultMinorDecorationPart2(_nameFbxFile, _nameFbx, _nameAsset, _stoneCost, _category)
    registerDefaultMinorDecorationPart(_nameFbxFile, _nameFbx, _nameAsset, _stoneCost, _optionPinionNodeType, _category)
    for i=0, 1 do
        StoneGate:registerPrefabComponent("models/decorations/" .. _nameFbxFile .. ".fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part/Attach_StoneGatePinion_" .. _nameFbx .. i, {
	    DataType = "COMP_BUILDING_ATTACH_NODE",
	    AttachNodeTypeList = { _optionPinionNodeType },
        })
    end
end

registerDefaultMinorDecorationPart("pinion", "Pinion2Stone45", "PINION2_STONE45", 2, "MINOR", StoneGateSetPrefix .. "_KEEP_PARTSETLIST_NAME")

function registerPinionColor(_color, _COLOR, _stoneCost)
    function registerPinion2ShedAngle(_angle, _category2)
        registerDefaultMinorDecorationPart2("pinion", "Pinion2LeftShed" .. _color .. _angle, "PINION2_LEFT_SHED_" .. _COLOR .. _angle, _stoneCost, _category2)
        registerDefaultMinorDecorationPart2("pinion", "Pinion2RightShed" .. _color .. _angle, "PINION2_RIGHT_SHED_" .. _COLOR .. _angle, _stoneCost, _category2)
    end
    function registerPinionAngle(_angle, _category2, _category1)
        registerDefaultMinorDecorationPart("pinion", "Pinion1Simple" .. _color .. _angle, "PINION1_SIMPLE_" .. _COLOR .. _angle, _stoneCost, "MINOR", _category1)
        registerDefaultMinorDecorationPart("pinion", "Pinion1Shed" .. _color .. _angle, "PINION1_SHED_" .. _COLOR .. _angle, _stoneCost, "MINOR", _category1)
        registerDefaultMinorDecorationPart2("pinion", "Pinion2Simple" .. _color .. _angle, "PINION2_SIMPLE_" .. _COLOR .. _angle, _stoneCost, _category2)
        registerPinion2ShedAngle(_angle, _category2)
    end
    registerPinionAngle("45", StoneGateSetPrefix .. "_KEEP_PARTSETLIST_NAME", StoneGateSetPrefix .. "_SST_PARTSETLIST_NAME")
    registerPinionAngle("30", StoneGateSetPrefix .. "_KEEP30_PARTSETLIST_NAME", StoneGateSetPrefix .. "_SST30_PARTSETLIST_NAME")
    registerPinion2ShedAngle("24", StoneGateSetPrefix .. "_KEEP30_PARTSETLIST_NAME", StoneGateSetPrefix .. "_SST30_PARTSETLIST_NAME")
    registerPinionAngle("60", StoneGateSetPrefix .. "_KEEP60_PARTSETLIST_NAME", StoneGateSetPrefix .. "_SST60_PARTSETLIST_NAME")
end
registerPinionColor("Cream", "CREAM", 0)
registerPinionColor("White", "WHITE", 0)
registerPinionColor("Stone", "STONE", 2)
registerPinionColor("Wood",  "WOOD",  0)


